/*

UserList.java

This is an object that helps to manage a list
of users and their associated busy times

*/
package A08.model;

import java.util.*;
import java.lang.*;

public class UserList {

    
    Vector uList;

    public UserList() {

	uList = new Vector();
    }

    public void addUser(String name) {
	Iterator it = uList.iterator();

	while(it.hasNext()) {
	    User temp = (User)it.next();
	    if(name.equals(temp.getName())) {
		return;
	    }
	}
	uList.add(new User(name));
    }

    public void addBusyBlock(String name, TimeUnit t) {

	//this checks to see if the name already exists
	Iterator it = uList.iterator();
	while(it.hasNext()) {
	    User temp = (User)it.next();
	    if (name.equals(temp.getName())) {
		temp.addBusyBlock(t);
		return;
	    }
	}

	//if it doesnt, create a new user
	//and add the time
	this.addUser(name);
	this.addBusyBlock(name, t);

	return;
    }

    //returns just a String of the users
    public String getUserList() {
	String result = "";
	
	Iterator it = uList.iterator(); 

	while(it.hasNext()) {
	    User temp = (User)it.next();
	    result += temp.getName() + "\n";
	}
	
	return result;
    }

    //returns a String of the users and their busy times
    public String getUserBusyBlockList() {
	String result = "";
	
	Iterator it = uList.iterator(); 

	while(it.hasNext()) {
	    User temp = (User)it.next();
	    result += temp.getBusyBlocks();
	}

	return result;
    }
    
    public void clearUserList() {
	uList = new Vector();
    }
}
