package A08.web;

import A08.model.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*; // for List and Iterator

public class SchedulerController extends HttpServlet {

    Scheduler myScheduler = new Scheduler();
    UserList myUserList = new UserList();
    String userName = new String();
    int c_start_h = 8;
    int c_start_m = 0;
    int c_end_h = 17;
    int c_end_m = 0;
    
    public void doPost(HttpServletRequest request,
                       HttpServletResponse response)
                       throws IOException, ServletException {

        String command = request.getParameter("WhatToDo");

        //myScheduler.setTimeConstraint_StartTime(c_start_h,
	//					c_start_m);
        //myScheduler.setTimeConstraint_EndTime(c_end_h,
	//				      c_end_m);

        RequestDispatcher view;
       
        if(command.equals("AddBusyBlock")){

            //Get the parameters
            userName = request.getParameter("user");
            int weekday = Integer.parseInt(request.getParameter("weekday"));
            int start_h = Integer.parseInt(request.getParameter("start_h"));
            int start_m = Integer.parseInt(request.getParameter("start_m"));
            int end_h = Integer.parseInt(request.getParameter("end_h"));
            int end_m = Integer.parseInt(request.getParameter("end_m"));
            
            //make a new TimeUnit with the params and add it to the busy block.
            TimeUnit time = new TimeUnit(weekday, start_h, start_m, end_h, end_m);

	    c_start_h = Integer.parseInt(request.getParameter("cstarth"));
	    c_start_m = Integer.parseInt(request.getParameter("cstartm"));
	    c_end_h = Integer.parseInt(request.getParameter("cendh"));
	    c_end_m = Integer.parseInt(request.getParameter("cendm"));

	    myScheduler.setTimeConstraint_StartTime(c_start_h,
						    c_start_m);
	    myScheduler.setTimeConstraint_EndTime(c_end_h,
						  c_end_m);
	    
	    //add the busy block to both the schedule and user list
            myScheduler.addBusyBlock(time);
	    myUserList.addBusyBlock(userName,time);
            
            view = request.getRequestDispatcher("form.jsp");
        }
        else if(command.equals("ClearSchedule")){
            myScheduler.clearSchedule();
	    myUserList.clearUserList();
	    userName = "";
            view = request.getRequestDispatcher("form.jsp");
        }
        else{
            //error page
            view = request.getRequestDispatcher("error.jsp");
        }

	
        String csh = "";
	csh += "" + c_start_h;
	String csm = "";
	csm += "" + c_start_m;
	String ceh = "";
	ceh += "" + c_end_h;
	String cem = "";
	cem += "" + c_end_m;
        
        request.setAttribute("freeTime", myScheduler.getFreeTimes());
	request.setAttribute("userList", myUserList.getUserBusyBlockList());
	request.setAttribute("lastName", userName);
	request.setAttribute("lastcstarth",csh);
	request.setAttribute("lastcstartm",csm);
	request.setAttribute("lastcendh",ceh);
	request.setAttribute("lastcendm",cem);
        view.forward(request, response);
        
    }
}

